@echo off
SET AsmName=loader
SET EngName=mlde32

if not exist %AsmName%.asm goto FileNotFound

tasm32 /ml /m3 /z %AsmName%.asm, %EngName%.obj
if not exist %EngName%.obj goto CompilerError

tlink -x /3 /t %EngName%.obj,%EngName%.bin
if not errorlevel 1 goto Success

:FileNotFound
ECHO Could not find %AsmName%.asm
ECHO Could Not Compile!
pause > nul
goto fim

:NoHaxor
cls
ECHO Could not run haxor.exe, this make needs that tool 
ECHO to properly make includes, download it at:
ECHO          http://z0mbie.host.sk
pause > nul
goto fim

:CompilerError
ECHO Compiler Error!
pause > nul
goto fim

:Success
ECHO Success!
haxor /asm %EngName%.bin %EngName%.tmp @%EngName%
if  not exist %EngName%.tmp goto NoHaxor

haxor /asm %EngName%.bin %EngName%.inc @%EngName%

type %EngName%.inc | find /v "!" > %EngName%.tmp

echo ;***************************************> %EngName%.inc
echo ;* (X) uNdErX - underx@antisocial.com  *>> %EngName%.inc
echo ;***************************************>> %EngName%.inc
echo ;* Micro Length-Disassembler Engine 32 *>> %EngName%.inc
echo ;***************************************>> %EngName%.inc
echo ;* int __cdecl mlde32(void *codeptr);  *>> %EngName%.inc
echo ;***************************************>> %EngName%.inc
type %EngName%.tmp >> %EngName%.inc

del %EngName%.bin
del %EngName%.tmp

move %EngName%.obj ..\%EngName%.obj
move %EngName%.inc ..\%EngName%.inc

:fim
pause
